#ifndef __GET_OPTION_FLAG_F__
#define __GET_OPTION_FLAG_F__
/*
  ȈՃp[^擾AIvV̔ATu[`	Ver.1.05c
  
  vs_value
  
  GȃIvV̎s_cmdlines_getoptgpB
  
  Ver.1.00 2012/01/09 get_option_flag()łƂ肠쐬
  Ver.1.01 2012/11/15 get_argv_*()ǉ
  Ver.1.02 2012/12/03 -i- ݂ȃIvVwɑΉ
  Ver.1.03 2012/12/30 inc_argc_argv}Nǉ
  Ver.1.04 2013/01/28 p[^擾̕CɂȂĂ̂ŖOύX
  Ver.1.05 2014/07/09 is_option_argc()ǉ

  g
  char *param;
  int param_int;
  
  param     = get_argv_def(&argc,&argv,NULL);
  param_int = get_argv_int_def(&argc,&argv,0);

  IvV̊l
  int debug_flag

  debug_flag = get_option_flag('d',&argc,&argv);

  debug_flag = FALSE;
  debug_flag |= get_option_flag('d',&argc,&argv);

  IvVp[^̊l
  if(get_option_flag('f',&argc,&argv)) f = get_argv(&argc,&argv);
  if(get_option_flag('c',&argc,&argv)) c = get_argv_int(&argc,&argv);

  if(get_option_flag('f',&argc,&argv)) f = get_argv_def(&argc,&argv,DEF_F);
  if(get_option_flag('c',&argc,&argv)) c = get_argv_int_def(&argc,&argv,DEF_C);

  if(is_option_argc(&argc,&argv) printf("Option error.\n");
*/
#include <stdlib.h>
#include <ctype.h>
#include <math.h>

#include "s_value.h"

int is_option_argc(int *argc,char **argv[])
{
  if(*argc > 1)
    {
      switch((*argv)[1][0])
	{
	case '-':
#ifdef __windows__
	case '/':
#endif
	  return(TRUE);
	  break;
	}
    }
  return(FALSE);
}

#define inc_argc_argv(argc,argv)	((argc)--);((argv)++);
#define get_option_flag(c,argc,argv)	get_option_flag_def(c,argc,argv,FALSE)

int get_option_flag_def(char c,int *argc,char **argv[],int def)
{
  char e;
  e = tolower(c);
  
  if(is_option_argc(argc,argv))
    {
      if(tolower((*argv)[1][1]) == e)
	{
	  if((*argv)[1][2] == '\0')
	    {
	      (*argc)--;
	      (*argv)++;
	      return(TRUE);
	    }
	  if(((*argv)[1][2] == '-') && ((*argv)[1][3] == '\0'))
	    {
	      (*argc)--;
	      (*argv)++;
	      return(FALSE);
	    }
	}
    }
  return(def);
}

char *get_argv_def(int *argc,char **argv[],char *def)
{
  if((*argc) <= 1) return(def);
  (*argc)--; (*argv)++;
  return((*argv)[0]);
}

int get_argv_int_def(int *argc,char **argv[],int def)
{
  if((*argc) <= 1) return(def);
  (*argc)--; (*argv)++;
  return(atoi((*argv)[0]));
}

#define get_argv_uc_def(c,v,d)	(unsigned char)get_argv_int(c,v,d)
#define get_argv_char_def(c,v,d)	(char)get_argv_int(c,v,d)
#define get_argv_short_def(c,v,d)	(short)get_argv_int(c,v,d)

long get_argv_long_def(int *argc,char **argv[],long def)
{
  if(*argc <= 1) return(def);
  (*argc)--; (*argv)++;
  return(atol((*argv)[0]));
}

long long get_argv_long_long_def(int *argc,char **argv[],long long def)
{
  if(*argc <= 1) return(def);
  (*argc)--; (*argv)++;
#ifdef __windows__
  return(_atoi64((*argv)[0]));
#else
  return(atoll((*argv)[0]));
#endif
}

double get_argv_double_def(int *argc,char **argv[],double def)
{
  if(*argc <= 1) return(def);
  (*argc)--; (*argv)++;
  return(atof((*argv)[0]));
}
#define get_argv_float_def(c,v,d)	(float)get_argv_double_def(c,v,d)

// _def̖̂`
#define get_argv(c,v)		get_argv_def(c,v,NULL)
#define get_argv_int(c,v)	get_argv_int_def(c,v,0)
#define get_argv_uc(c,v)	get_argv_uc_def(c,v,0)
#define get_argv_char(c,v)	get_argv_char_def(c,v,0)
#define get_argv_short(c,v)	get_argv_short_def(c,v,0)
#define get_argv_long(c,v)	get_argv_long_def(c,v,0L)
#define get_argv_long_long(c,v)	get_argv_long_long_def(c,v,0LL)
#define get_argv_float(c,v)	get_argv_float_def(c,v,0.0)
#define get_argv_double(c,v)	get_argv_double_def(c,v,0.0)

#endif
